﻿<?php
// Für die Objektorientierung
class Person {
	//Attribute
	private $gewicht;
	private $groesse;
	private $bmi;
	private $alter;
	private $geschlecht;
	private $min;
	private $max;
	private $klassifikation;
	
	
	//Konstruktor
	function __construct() {
		
	}
	
	//Get-und Set-Methoden
	public function set_gewicht($pGewicht) {
		$this->gewicht = $pGewicht;
	}
	
	public function get_gewicht() {
		return $this->gewicht;
	}
	
	public function set_groesse($pGroesse) {
		$this->groesse = $pGroesse;
	}
	
	public function get_groesse() {
		return $this->groesse;
	}
	
	public function set_bmi($pBmi) {
		$this->bmi = $pBmi;
	}
	
	public function get_bmi() {
		return $this->bmi;
	}
		
	public function set_alter($pAlter) {
		$this->alter = $pAlter;
	}
	
	public function get_alter() {
		return $this->alter;
	}
	
	public function set_geschlecht($pGeschlecht) {
		$this->geschlecht = $pGeschlecht;
	}
	
	public function get_geschlecht() {
		return $this->geschlecht;
	}
	
	public function set_min($pMin) {
		$this->min = $pMin;
	}
	
	public function get_min() {
		return $this->min;
	}
	
	public function set_max($pMax) {
		$this->max = $pMax;
	}
	
	public function get_max() {
		return $this->max;
	}
	
	public function set_klassifikation($pKlassifikation) {
		$this->klassifikation = $pKlassifikation;
	}
	
	public function get_klassifikation() {
		return $this->klassifikation;
	}
	
	
	public function klassifiziere(){
	
	}
	
	public function bestimme_opt(){
		$mAlter = $this -> get_alter();
		if($mAlter>= 19 && $mAlter<24){
			$this->set_min(19);
			$this->set_max(29);
		}elseif($mAlter>=25 && $mAlter<35){
			$this->set_min(20);
			$this->set_max(25);
		}elseif($mAlter>=35 && $mAlter<45){
			$this->set_min(21);
			$this->set_max(26);
		}elseif($mAlter>=45 && $mAlter<55){
			$this->set_min(22);
			$this->set_max(27);
		}elseif($mAlter>=55 && $mAlter<65){
			$this->set_min(23);
			$this->set_max(28);
		}elseif($mAlter>= 65){
			$this->set_min(24);
			$this->set_max(29);
		}else{
			echo "<br />Sie sind jünger als 19 Jahre.";
		}
	}
	
	public function pruefe($pOperator) {
		$mOK = false;
		if ($pOperator == "keiner") {
			$mOK = true;
			throw new Exception("Bitte wählen Sie ein Geschlecht!");
		}
		return $mOK;
	}
}

class Frau extends Person{	
	
	public function klassifiziere($bmi){

		if(19 > $bmi){
			$this->set_klassifikation("Untergewicht");
		}elseif(19 <= $bmi && $bmi <= 24 ){
			$this->set_klassifikation("Normalgewicht");
		}elseif(24 < $bmi && $bmi <= 30 ){
			$this->set_klassifikation("Übergewicht");
		}elseif(30 < $bmi && $bmi <= 40 ){
			$this->set_klassifikation("Adipositas");
		}elseif($this->$bmi > 40 ){
			$this->set_klassifikation("Schwere Adipositas");
		}else{
			echo "Die Klassifikation anhand des Alters ist gescheitert!";
		}
	}
	
}

class Mann extends Person{
	
	public function klassifiziere($bmi){
		if(20 > $bmi){
			$this->set_klassifikation("Untergewicht");
		}elseif(20 <= $bmi && $bmi <= 25 ){
			$this->set_klassifikation("Normalgewicht");
		}elseif(25 < $bmi && $bmi <= 30 ){
			$this->set_klassifikation("Übergewicht");
		}elseif(30 < $bmi && $bmi <= 40 ){
			$this->set_klassifikation("Adipositas");
		}else{
			$this->set_klassifikation("Schwere Adipositas");
		}
	}

	/*public function bestimme_opt($person){
		$mAlter = $person -> get_alter();
		if($mAlter >= 19 && $mAlter <24){
			$this->set_min(20);
			$this->set_max(29);
		}elseif($mAlter >=25 && $mAlter <35){
			$this->set_min(20);
			$this->set_max(25);
		}elseif($mAlter >=35 && $mAlter <45){
			$this->set_min(21);
			$this->set_max(26);
		}elseif($mAlter >=45 && $mAlter <55){
			$this->set_min(22);
			$this->set_max(27);
		}elseif($mAlter >=55 && $mAlter <65){
			$this->set_min(23);
			$this->set_max(28);
		}elseif($mAlter >= 65){
			$this->set_min(24);
			$this->set_max(29);
		}else{
			echo "<br />Sie sind jünger als 19 Jahre.";
		}
	}*/
}





class Berechnung {
	//Attribute
	private $durchschnitt;
	private $bmi;
	private $person;
	
	//Konstruktor
	function __construct() {
	}
	
	//Get- und Set-Methoden
	public function set_durchschnitt($pDurchschnitt) {
		$this->durchschnitt = $pDurchschnitt;
	}
	
	public function get_durchschnitt() {
		return $this->durchschnitt;
	}
	
	
	//Höhere Methoden
	public function berechne_durchschnitt($pMathe, $pDeutsch, $pEnglisch, $pBwl) {
		$pErgebnis = ($pMathe + $pDeutsch + $pEnglisch + $pBwl) / 4;
		$this->set_durchschnitt($pDurchschnitt);
		return $pErgebnis;
	}
	
	public function berechne_bmi(Person $pPerson) {
		$mGewicht = $pPerson->get_gewicht();
		$mGroesse = $pPerson->get_groesse();

		
		if ($mGroesse == 0) {
			$pErgebnis = "Division durch Null nicht möglich!<br>Bitte geben Sie für die Gr&ouml;&szlig;e ein!";
		} else {
			$pErgebnis = $mGewicht/ ($mGroesse * $mGroesse);
           	$pPerson->set_bmi($pErgebnis);
		}
		return $pErgebnis;
	}
}
?>